/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/*
 * lwm2-hwc-papi.h
 *
 *  Created on: Jun 21, 2011
 *      Author: schleiden
 */

#ifndef LWM2_HWC_PAPI_H_
#define LWM2_HWC_PAPI_H_

void lwm2_hwc_papi_init(void);
void lwm2_hwc_papi_destroy(int event_set);

/**
 * Return the value of the specified hardware counter
 */
int lwm2_hwc_papi_get_counter_value(int counter);


extern unsigned long lwm2_hwc_config;
extern unsigned long lwm2_hwc_registered;

#ifdef LWM2_MEASUREMENT_HWCOUNTER

unsigned long lwm2_hwc_get_hwc_config();

int lwm2_hwc_papi_translate(int counter);
int lwm2_hwc_papi_add_counter(struct lwm2_hwc_storage* hwc_storage, int papi_event, int counter);
int lwm2_hwc_papi_add_custom_counter(struct lwm2_hwc_storage* hwc_storage, int papi_event);
int lwm2_hwc_papi_add_default_counter(struct lwm2_hwc_storage* hwc_storage, int counter);

void lwm2_hwc_papi_start(int event_set);
void lwm2_hwc_papi_destroy(int event_set);

void lwm2_hwc_papi_setup(void* thread_storage);

#endif

#endif /* LWM2_HWC_PAPI_H_ */
