/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_CUDA_ADAPTER_H_
#define LWM2_CUDA_ADAPTER_H_

extern int lwm2_cupti_app;

extern int lwm2_cuda_function_call;

#include "../lwm2-config.h"

#ifdef LWM2_MEASUREMENT_CUDA

#include <cuda.h>
#include <cupti.h>

typedef struct context_event {
	CUcontext context;
	CUpti_EventGroup event_group;
	uint64_t* values;
	uint64_t* old_values;
} context_event_t;
 
// typedef struct cuda_device {
//	 unsigned char device;
//	 char device_name[32];
//	 EpkVector* contexts;
// } cuda_device_t;

enum {
	LWM2_ADAPTER_CUDA_INSTRUCTION,
	LWM2_ADAPTER_CUDA_DIV_BRANCH
};

#define LWM2_CUDA_EVENT_COUNT  1

extern CUpti_EventID lwm2_cuda_event_ids[LWM2_CUDA_EVENT_COUNT];

extern int lwm2_cuda_device_count;

typedef uint64_t cuda_timestamp_t;

int lwm2_cupti_init();

char* lwm2_get_event_for_device(int index, CUdevice device);

void CUPTIAPI getTimestampCallback(void *userdata, CUpti_CallbackDomain domain,
                     CUpti_CallbackId cbid, const CUpti_CallbackData *cbInfo);

int lwm2_adapter_cuda_is_cuda_event(int event_id);

void CUPTIAPI handle_context(void *userdata, CUpti_CallbackDomain domain,
                      CUpti_CallbackId cbid, const CUpti_CallbackData *cbInfo);

void CUPTIAPI handle_cuInit(void *userdata, CUpti_CallbackDomain domain,
                      CUpti_CallbackId cbid, const CUpti_CallbackData *cbInfo);

double get_cuda_time(const CUpti_CallbackData *cbInfo, CUpti_CallbackId cbid);

void lwm2_cuda_subscribe_to_events_for_context(context_event_t* ctx_evt, unsigned char device);




#endif


#define LWM2_CUDA_FUNCTION_COUNT 175

#define LWM2_CUDA_DEV_COUNT 8

#endif
