/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_HWC_H_
#define LWM2_HWC_H_

#define LWM2_CPU_HWC_COUNT 4
#define LWM2_CACHE_HWC_COUNT 2

#ifndef LWM2_HWC_EXTERN_DEF
#define LWM2_HWC_COUNT (LWM2_CPU_HWC_COUNT + LWM2_CACHE_HWC_COUNT)
#else
#include "../modules/hwc/lwm2-hwc-num.h"
#define LWM2_HWC_COUNT LWM2_CUSTOM_BASIC_HWC_COUNT
#endif

#include "../lwm2-config.h"

#ifdef LWM2_MEASUREMENT_HWCOUNTER
#include  <papi.h>


extern int lwm2_num_counters_available;

extern int cpu_events;

struct lwm2_hwc_storage {
	long_long values[LWM2_HWC_COUNT];
	long_long old_values[LWM2_HWC_COUNT];
	int event_ids[LWM2_HWC_COUNT];
	int num_counters;
	int event_set;
};

extern struct lwm2_hwc_storage lwm2_proc_hwc_storage;

#endif

enum
{
	/* General hardware counters */
	LWM2_HWCOUNTER_CYCLES,
	LWM2_HWCOUNTER_FP_OPS,
	LWM2_HWCOUNTER_FP_INS,
	LWM2_HWCOUNTER_INST,

	/* General */
	LWM2_HWCOUNTER_L1_DATA_ACCESS,
	LWM2_HWCOUNTER_L1_DATA_MISSES,
	
	LWM2_HWCOUNTER_LOADS,
	LWM2_HWCOUNTER_STORES,
	

	/* Local cache */
	LWM2_HWCOUNTER_L1_INS_MISSES,

	LWM2_HWCOUNTER_L1_INS_HITS,
	
	LWM2_HWCOUNTER_L1_LOAD_MISSES,
	LWM2_HWCOUNTER_L1_STORE_MISSES,
	
	LWM2_HWCOUNTER_LOAD_INST,
	LWM2_HWCOUNTER_STORE_INST,
	
	LWM2_HWCOUNTER_LOAD_STORE_INST
};

enum lwm2_hwc_config_codes {
	LWM2_HWC_CPI = 1,
	LWM2_HWC_FLOPS = 2,
	LWM2_HWC_FLOINS = 4,
	LWM2_HWC_L1_RATIO = 8,
	LWM2_HWC_LOAD_STORE_RATIO = 16,
};



#endif /* LWM2_HWC_H_ */
