/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_MPI_CONFIG_H_
#define LWM2_MPI_CONFIG_H_

#include "lwm2-mpi-adapter.h"


//#define HAS_MPI_IN_PLACE
#define HAS_MPI_ABORT
#define HAS_MPI_ACCUMULATE
#define HAS_MPI_ADD_ERROR_CLASS
#define HAS_MPI_ADD_ERROR_CODE
#define HAS_MPI_ADD_ERROR_STRING
#define HAS_MPI_ADDRESS
#define HAS_MPI_ALLGATHER
#define HAS_MPI_ALLGATHERV
#define HAS_MPI_ALLOC_MEM
#define HAS_MPI_ALLREDUCE
#define HAS_MPI_ALLTOALL
#define HAS_MPI_ALLTOALLV
#define HAS_MPI_ALLTOALLW
#define HAS_MPI_ATTR_DELETE
#define HAS_MPI_ATTR_GET
#define HAS_MPI_ATTR_PUT
#define HAS_MPI_BARRIER
#define HAS_MPI_BCAST
#define HAS_MPI_BSEND
#define HAS_MPI_BSEND_INIT
#define HAS_MPI_BUFFER_ATTACH
#define HAS_MPI_BUFFER_DETACH
#define HAS_MPI_CANCEL
#define HAS_MPI_CART_COORDS
#define HAS_MPI_CART_CREATE
#define HAS_MPI_CART_GET
#define HAS_MPI_CART_MAP
#define HAS_MPI_CART_RANK
#define HAS_MPI_CART_SHIFT
#define HAS_MPI_CART_SUB
#define HAS_MPI_CARTDIM_GET
#define HAS_MPI_CLOSE_PORT
#define HAS_MPI_COMM_ACCEPT
#define HAS_MPI_COMM_C
#define HAS_MPI_COMM_CALL_ERRHANDLER
#define HAS_MPI_COMM_COMPARE
#define HAS_MPI_COMM_CONNECT
#define HAS_MPI_COMM_CREATE
#define HAS_MPI_COMM_CREATE_ERRHANDLER
#define HAS_MPI_COMM_CREATE_KEYVAL
#define HAS_MPI_COMM_DELETE_ATTR
#define HAS_MPI_COMM_DISCONNECT
#define HAS_MPI_COMM_DUP
#define HAS_MPI_COMM_F
#define HAS_MPI_COMM_FREE
#define HAS_MPI_COMM_FREE_KEYVAL
#define HAS_MPI_COMM_GET_ATTR
#define HAS_MPI_COMM_GET_ERRHANDLER
#define HAS_MPI_COMM_GET_NAME
#define HAS_MPI_COMM_GET_PARENT
#define HAS_MPI_COMM_GROUP
#define HAS_MPI_COMM_JOIN
#define HAS_MPI_COMM_RANK
#define HAS_MPI_COMM_REMOTE_GROUP
#define HAS_MPI_COMM_REMOTE_SIZE
#define HAS_MPI_COMM_SET_ATTR
#define HAS_MPI_COMM_SET_ERRHANDLER
#define HAS_MPI_COMM_SET_NAME
#define HAS_MPI_COMM_SIZE
#define HAS_MPI_COMM_SPAWN
#define HAS_MPI_COMM_SPAWN_MULTIPLE
#define HAS_MPI_COMM_SPLIT
#define HAS_MPI_COMM_TEST_INTER
#define HAS_MPI_DIMS_CREATE
/* #define HAS_MPI_DIST_GRAPH_CREATE */
/* #define HAS_MPI_DIST_GRAPH_CREATE_ADJACENT */
/* #define HAS_MPI_DIST_GRAPH_NEIGHBORS */
/* #define HAS_MPI_DIST_GRAPH_NEIGHBORS_COUNT */
#define HAS_MPI_ERRHANDLER_CREATE
#define HAS_MPI_ERRHANDLER_FREE
#define HAS_MPI_ERRHANDLER_GET
#define HAS_MPI_ERRHANDLER_SET
#define HAS_MPI_ERROR_CLASS
#define HAS_MPI_ERROR_STRING
#define HAS_MPI_EXSCAN
#define HAS_MPI_FILE_C
#define HAS_MPI_FILE_CALL_ERRHANDLER
#define HAS_MPI_FILE_CLOSE
#define HAS_MPI_FILE_CREATE_ERRHANDLER
#define HAS_MPI_FILE_DELETE
#define HAS_MPI_FILE_F
#define HAS_MPI_FILE_GET_AMODE
#define HAS_MPI_FILE_GET_ATOMICITY
#define HAS_MPI_FILE_GET_BYTE_OFFSET
#define HAS_MPI_FILE_GET_ERRHANDLER
#define HAS_MPI_FILE_GET_GROUP
#define HAS_MPI_FILE_GET_INFO
#define HAS_MPI_FILE_GET_POSITION
#define HAS_MPI_FILE_GET_POSITION_SHARED
#define HAS_MPI_FILE_GET_SIZE
#define HAS_MPI_FILE_GET_TYPE_EXTENT
#define HAS_MPI_FILE_GET_VIEW
#define HAS_MPI_FILE_IREAD
#define HAS_MPI_FILE_IREAD_AT
#define HAS_MPI_FILE_IREAD_SHARED
#define HAS_MPI_FILE_IWRITE
#define HAS_MPI_FILE_IWRITE_AT
#define HAS_MPI_FILE_IWRITE_SHARED
#define HAS_MPI_FILE_OPEN
#define HAS_MPI_FILE_PREALLOCATE
#define HAS_MPI_FILE_READ
#define HAS_MPI_FILE_READ_ALL
#define HAS_MPI_FILE_READ_ALL_BEGIN
#define HAS_MPI_FILE_READ_ALL_END
#define HAS_MPI_FILE_READ_AT
#define HAS_MPI_FILE_READ_AT_ALL
#define HAS_MPI_FILE_READ_AT_ALL_BEGIN
#define HAS_MPI_FILE_READ_AT_ALL_END
#define HAS_MPI_FILE_READ_ORDERED
#define HAS_MPI_FILE_READ_ORDERED_BEGIN
#define HAS_MPI_FILE_READ_ORDERED_END
#define HAS_MPI_FILE_READ_SHARED
#define HAS_MPI_FILE_SEEK
#define HAS_MPI_FILE_SEEK_SHARED
#define HAS_MPI_FILE_SET_ATOMICITY
#define HAS_MPI_FILE_SET_ERRHANDLER
#define HAS_MPI_FILE_SET_INFO
#define HAS_MPI_FILE_SET_SIZE
#define HAS_MPI_FILE_SET_VIEW
#define HAS_MPI_FILE_SYNC
#define HAS_MPI_FILE_WRITE
#define HAS_MPI_FILE_WRITE_ALL
#define HAS_MPI_FILE_WRITE_ALL_BEGIN
#define HAS_MPI_FILE_WRITE_ALL_END
#define HAS_MPI_FILE_WRITE_AT
#define HAS_MPI_FILE_WRITE_AT_ALL
#define HAS_MPI_FILE_WRITE_AT_ALL_BEGIN
#define HAS_MPI_FILE_WRITE_AT_ALL_END
#define HAS_MPI_FILE_WRITE_ORDERED
#define HAS_MPI_FILE_WRITE_ORDERED_BEGIN
#define HAS_MPI_FILE_WRITE_ORDERED_END
#define HAS_MPI_FILE_WRITE_SHARED
#define HAS_MPI_FINALIZE
#define HAS_MPI_FINALIZED
#define HAS_MPI_FREE_MEM
#define HAS_MPI_GATHER
#define HAS_MPI_GATHERV
#define HAS_MPI_GET
#define HAS_MPI_GET_ADDRESS
#define HAS_MPI_GET_COUNT
#define HAS_MPI_GET_ELEMENTS
#define HAS_MPI_GET_PROCESSOR_NAME
#define HAS_MPI_GET_VERSION
#define HAS_MPI_GRAPH_CREATE
#define HAS_MPI_GRAPH_GET
#define HAS_MPI_GRAPH_MAP
#define HAS_MPI_GRAPH_NEIGHBORS
#define HAS_MPI_GRAPH_NEIGHBORS_COUNT
#define HAS_MPI_GRAPHDIMS_GET
#define HAS_MPI_GREQUEST_COMPLETE
#define HAS_MPI_GREQUEST_START
#define HAS_MPI_GROUP_C
#define HAS_MPI_GROUP_COMPARE
#define HAS_MPI_GROUP_DIFFERENCE
#define HAS_MPI_GROUP_EXCL
#define HAS_MPI_GROUP_F
#define HAS_MPI_GROUP_FREE
#define HAS_MPI_GROUP_INCL
#define HAS_MPI_GROUP_INTERSECTION
#define HAS_MPI_GROUP_RANGE_EXCL
#define HAS_MPI_GROUP_RANGE_INCL
#define HAS_MPI_GROUP_RANK
#define HAS_MPI_GROUP_SIZE
#define HAS_MPI_GROUP_TRANSLATE_RANKS
#define HAS_MPI_GROUP_UNION
#define HAS_MPI_IBSEND
#define HAS_MPI_INFO_C
#define HAS_MPI_INFO_CREATE
#define HAS_MPI_INFO_DELETE
#define HAS_MPI_INFO_DUP
#define HAS_MPI_INFO_F
#define HAS_MPI_INFO_FREE
#define HAS_MPI_INFO_GET
#define HAS_MPI_INFO_GET_NKEYS
#define HAS_MPI_INFO_GET_NTHKEY
#define HAS_MPI_INFO_GET_VALUELEN
#define HAS_MPI_INFO_SET
#define HAS_MPI_INIT_THREAD
#define HAS_MPI_INITIALIZED
#define HAS_MPI_INTERCOMM_CREATE
#define HAS_MPI_INTERCOMM_MERGE
#define HAS_MPI_IPROBE
#define HAS_MPI_IRECV
#define HAS_MPI_IRSEND
#define HAS_MPI_IS_THREAD_MAIN
#define HAS_MPI_ISEND
#define HAS_MPI_ISSEND
#define HAS_MPI_KEYVAL_CREATE
#define HAS_MPI_KEYVAL_FREE
#define HAS_MPI_LOOKUP_NAME
#define HAS_MPI_OP_C
//#define HAS_MPI_OP_COMMUTATIVE
#define HAS_MPI_OP_CREATE
#define HAS_MPI_OP_F
#define HAS_MPI_OP_FREE
#define HAS_MPI_OPEN_PORT
#define HAS_MPI_PACK
#define HAS_MPI_PACK_EXTERNAL
#define HAS_MPI_PACK_EXTERNAL_SIZE
#define HAS_MPI_PACK_SIZE
// #define HAS_MPI_PCONTROL
#define HAS_MPI_PROBE
#define HAS_MPI_PUBLISH_NAME
#define HAS_MPI_PUT
#define HAS_MPI_QUERY_THREAD
#define HAS_MPI_RECV
#define HAS_MPI_RECV_INIT
#define HAS_MPI_REDUCE
//#define HAS_MPI_REDUCE_LOCAL
#define HAS_MPI_REDUCE_SCATTER
//#define HAS_MPI_REDUCE_SCATTER_BLOCK
#define HAS_MPI_REGISTER_DATAREP
#define HAS_MPI_REQUEST_C
#define HAS_MPI_REQUEST_F
//#define HAS_MPI_REQUEST_FREE
#define HAS_MPI_REQUEST_GET_STATUS
#define HAS_MPI_RSEND
#define HAS_MPI_RSEND_INIT
#define HAS_MPI_SCAN
#define HAS_MPI_SCATTER
#define HAS_MPI_SCATTERV
#define HAS_MPI_SEND
#define HAS_MPI_SEND_INIT
#define HAS_MPI_SENDRECV
#define HAS_MPI_SENDRECV_REPLACE
//#define HAS_MPI_SIZEOF
#define HAS_MPI_SSEND
#define HAS_MPI_SSEND_INIT
#define HAS_MPI_START
#define HAS_MPI_STARTALL
#define HAS_MPI_STATUS_C
#define HAS_MPI_STATUS_F
#define HAS_MPI_STATUS_SET_CANCELLED
#define HAS_MPI_STATUS_SET_ELEMENTS
#define HAS_MPI_TEST
#define HAS_MPI_TEST_CANCELLED
#define HAS_MPI_TESTALL
#define HAS_MPI_TESTANY
#define HAS_MPI_TESTSOME
#define HAS_MPI_TOPO_TEST
#define HAS_MPI_TYPE_C
#define HAS_MPI_TYPE_COMMIT
#define HAS_MPI_TYPE_CONTIGUOUS
#define HAS_MPI_TYPE_CREATE_DARRAY
#define HAS_MPI_TYPE_CREATE_F
#define HAS_MPI_TYPE_CREATE_HINDEXED
#define HAS_MPI_TYPE_CREATE_HVECTOR
#define HAS_MPI_TYPE_CREATE_INDEXED_BLOCK
#define HAS_MPI_TYPE_CREATE_KEYVAL
#define HAS_MPI_TYPE_CREATE_RESIZED
#define HAS_MPI_TYPE_CREATE_STRUCT
#define HAS_MPI_TYPE_CREATE_SUBARRAY
#define HAS_MPI_TYPE_DELETE_ATTR
#define HAS_MPI_TYPE_DUP
#define HAS_MPI_TYPE_EXTENT
#define HAS_MPI_TYPE_F
#define HAS_MPI_TYPE_FREE
#define HAS_MPI_TYPE_FREE_KEYVAL
#define HAS_MPI_TYPE_GET_ATTR
#define HAS_MPI_TYPE_GET_CONTENTS
#define HAS_MPI_TYPE_GET_ENVELOPE
#define HAS_MPI_TYPE_GET_EXTENT
#define HAS_MPI_TYPE_GET_NAME
#define HAS_MPI_TYPE_GET_TRUE_EXTENT
#define HAS_MPI_TYPE_HINDEXED
#define HAS_MPI_TYPE_HVECTOR
#define HAS_MPI_TYPE_INDEXED
#define HAS_MPI_TYPE_LB
#define HAS_MPI_TYPE_MATCH_SIZE
#define HAS_MPI_TYPE_SET_ATTR
#define HAS_MPI_TYPE_SET_NAME
#define HAS_MPI_TYPE_SIZE
#define HAS_MPI_TYPE_STRUCT
#define HAS_MPI_TYPE_UB
#define HAS_MPI_TYPE_VECTOR
#define HAS_MPI_UNPACK
#define HAS_MPI_UNPACK_EXTERNAL
#define HAS_MPI_UNPUBLISH_NAME
#define HAS_MPI_WAIT
#define HAS_MPI_WAITALL
#define HAS_MPI_WAITANY
#define HAS_MPI_WAITSOME
#define HAS_MPI_WIN_C
#define HAS_MPI_WIN_CALL_ERRHANDLER
#define HAS_MPI_WIN_COMPLETE
#define HAS_MPI_WIN_CREATE
#define HAS_MPI_WIN_CREATE_ERRHANDLER
#define HAS_MPI_WIN_CREATE_KEYVAL
#define HAS_MPI_WIN_DELETE_ATTR
#define HAS_MPI_WIN_F
#define HAS_MPI_WIN_FENCE
#define HAS_MPI_WIN_FREE
#define HAS_MPI_WIN_FREE_KEYVAL
#define HAS_MPI_WIN_GET_ATTR
#define HAS_MPI_WIN_GET_ERRHANDLER
#define HAS_MPI_WIN_GET_GROUP
#define HAS_MPI_WIN_GET_NAME
#define HAS_MPI_WIN_LOCK
#define HAS_MPI_WIN_POST
#define HAS_MPI_WIN_SET_ATTR
#define HAS_MPI_WIN_SET_ERRHANDLER
#define HAS_MPI_WIN_SET_NAME
#define HAS_MPI_WIN_START
#define HAS_MPI_WIN_TEST
#define HAS_MPI_WIN_UNLOCK
#define HAS_MPI_WIN_WAIT
/*#define HAS_MPI_WTICK*/
/*#define HAS_MPI_WTIME*/


/* General transformation functions */
#define XSUFFIX(name)  name##_
#define XSUFFIX2(name) name##__
#define XPREFIX(name)  _##name
#define XPREFIX2(name) __##name

#define SUFFIX(name)  XSUFFIX(name)
#define SUFFIX2(name) XSUFFIX2(name)
#define PREFIX(name)  XPREFIX(name)
#define PREFIX2(name) XPREFIX2(name)

#define UPCASE(name)  name##_U
#define LOWCASE(name) name##_L

#define FSUB1(name) LOWCASE(name)
#define FSUB2(name) UPCASE(name)
#define FSUB3(name) SUFFIX(LOWCASE(name))
#define FSUB4(name) SUFFIX2(LOWCASE(name))

#endif /* LWM2_MPI_CONFIG_H_ */
