/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "../lwm2-config.h"

#define _GNU_SOURCE
#ifndef LWM2_NO_DLSYM
#include <dlfcn.h>
#endif

#include <stdlib.h>
#include <stdio.h>

#include "lwm2-omp-adapter.h"
#include "../lwm2-storage.h"
#include "../util/lwm2-log.h"

unsigned char lwm2_thread_id = 0;

char* lwm2_omp_names[] = {
		"Signal Hits",
		"Cond Timedwait"
};

#ifndef LWM2_NO_DLSYM

typedef int (*fptr_omp_set_num_threads)(int n);
fptr_omp_set_num_threads Pomp_set_num_threads = NULL;

void omp_set_num_threads(int n)
{
	Pomp_set_num_threads(n);
	lwm2_storage_check_set_max_threads(n);
}
#endif

void lwm2_wrapper_omp_init()
{
#ifndef LWM2_NO_DLSYM
	dlerror();
	
	Pomp_set_num_threads = (fptr_omp_set_num_threads) dlsym(RTLD_NEXT, "omp_set_num_threads");
	if(Pomp_set_num_threads == NULL)
	{
		LWM2LOG(2, "Couldn't get the original function for omp_set_num_threads()\n");
	}
#endif
	char *num_thrds = getenv("OMP_NUM_THREADS");
	int num_threads = 1;
	if(num_thrds != NULL)
	{
		num_threads = atoi(num_thrds);
	}
	
	lwm2_storage_check_set_max_threads(num_threads);
}
