/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_PTHREAD_ADAPTER_H_
#define LWM2_PTHREAD_ADAPTER_H_

enum
{
   LWM2_PTHREAD_CREATE = 1,
   LWM2_PTHREAD_JOIN = 2
};

enum
{
   LWM2_THREAD_OMP = 1,
   LWM2_THREAD_OMP_SPECIAL_CHECK = 2,
   LWM2_THREAD_OMP_SPECIAL = 4
};

enum {
	THREAD_UNKNOWN = 0,
	THREAD_WORKER,
	THREAD_MONITOR
};

extern pthread_rwlock_t lwm2_process_storage_lock;
extern pthread_key_t lwm2_pthread_data_key;

extern int lwm2_omp_thread_count;

int lwm2_adapter_pthread_init();

void lwm2_adapter_pthread_destroy();

int lwm2_adapter_pthread_is_thread_master();

void lwm2_adapter_pthread_custom_leave_pthread_create(pthread_t thread);

void lwm2_adapter_pthread_custom_enter_pthread_exit();

void lwm2_adapter_pthread_custom_enter_pthread_cancel();

#endif /* LWM2_PTHREAD_ADAPTER_H_ */
