/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_FILE_READER_H_
#define LWM2_FILE_READER_H_

#include "lwm2-file-common.h"

void lwm2_file_read_init(char* file_name);

int lwm2_file_read_init_definition();
void lwm2_file_read_finish_definition();

int lwm2_file_get_time_slice_length();
unsigned long lwm2_file_get_time_slice_count();
unsigned long lwm2_file_get_time_slice_start_time();
unsigned short lwm2_file_get_summary_sensor_count();
unsigned short lwm2_file_get_time_slice_sensor_count();
unsigned int lwm2_file_get_job_id();
unsigned int lwm2_file_get_process_count();

file_def_t lwm2_file_get_definition();

int lwm2_file_read_sensor_def(unsigned short *sensor_id, char* sensor_name);
int lwm2_file_read_process_mapping(unsigned int *process_id, char* node_name);

int lwm2_file_read_init_summary_file();
void lwm2_file_read_finish_summary_file();
void lwm2_file_read_process_summary_metrics(unsigned long long* metric_values);
void lwm2_file_skip_process_summaries(unsigned int num_processes);

int lwm2_file_read_init_time_slice_file();
void lwm2_file_read_finish_time_slice_file();

void lwm2_file_read_process_mertric_val(unsigned long long *metric_value);
void lwm2_file_read_process_time_slice(unsigned long long *time_slice_metrics);
void lwm2_file_read_process_time_slice_with_count(int count, unsigned long long *time_slice_metrics);
void lwm2_file_skip_time_slices(long num_time_slices);
void lwm2_file_skip_process_from_start(unsigned int num_processes);
void lwm2_file_read_process_data(unsigned long long *proc_data, int time_slice_count, int time_slice_offset);
void lwm2file_cube_copy_time_slice_to_proc(unsigned long long* buff, unsigned long long* proc_data, int proc_count, int time_slice_count, int proc);

#endif
