/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_FILE_WRITER_H_
#define LWM2_FILE_WRITER_H_

void lwm2_file_init_writer(char* file_name);
void lwm2_file_close_definition_file();

void lwm2_file_init_time_slice_file();
void lwm2_file_close_time_slice_file();
void lwm2_file_init_summary_file();
void lwm2_file_close_summary_file();

void lwm2_file_set_time_slice_length(int time_slice_length);
void lwm2_file_set_time_slice_metric_count(unsigned short time_slice_metric_count);
void lwm2_file_set_summary_metric_count(unsigned short summary_metric_count);
void lwm2_file_set_job_id(unsigned int job_id);
void lwm2_file_set_process_count(unsigned int process_count);
void lwm2_file_set_time_slice_start_time(unsigned long time_slice_start_time);
void lwm2_file_set_time_slice_count(unsigned long time_slice_count);

void lwm2_file_write_summary_process_data(unsigned long long* summary_data);

void lwm2_file_write_definition();

void lwm2_file_write_sensor_def(unsigned short sensor_id, char* sensor_name);

void lwm2_file_write_process_mapping(unsigned int process_id, char* node_name);

void lwm2_file_append_process_metric_value(unsigned long long metric_val);

void lwm2_file_append_process_time_slice(unsigned long long *time_slice_metrics);



#endif
