/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/


#include "../include/lwm2-file-reader-def.h"

#include <stdio.h>

#define CHECK_HANDLE(X) if((X) == NULL) { return 0; }

FILE* rdef_file_handle = NULL;

int lwm2_file_reader_def_file_def(char* file_name, file_def_t* file_definition)
{
	rdef_file_handle = fopen(file_name, "r");
	CHECK_HANDLE(rdef_file_handle);
	
	char left_str[64];
	char split_char[4];
	char end_char[4];
	
	//version
	fscanf(rdef_file_handle, "%[^=]%[=]%d%[\n]", left_str, split_char, &file_definition->version, end_char);
	//time slice length
	fscanf(rdef_file_handle, "%[^=]%[=]%d%[\n]", left_str, split_char, &file_definition->time_slice_length, end_char);
	//time slice count
	fscanf(rdef_file_handle, "%[^=]%[=]%lu%[\n]", left_str, split_char, &file_definition->time_slice_count, end_char);
	//time slice start time
	fscanf(rdef_file_handle, "%[^=]%[=]%lu%[\n]", left_str, split_char, &file_definition->time_slice_start_time, end_char);
	//summary sensor count
	fscanf(rdef_file_handle, "%[^=]%[=]%hu%[\n]", left_str, split_char, &file_definition->summary_metric_count, end_char);
	//time-slice sensor count
	fscanf(rdef_file_handle, "%[^=]%[=]%hu%[\n]", left_str, split_char, &file_definition->time_slice_metric_count, end_char);
	//job id
	fscanf(rdef_file_handle, "%[^=]%[=]%u%[\n]", left_str, split_char, &file_definition->job_id, end_char);
	//process count
	fscanf(rdef_file_handle, "%[^=]%[=]%u%[\n]", left_str, split_char, &file_definition->process_count, end_char);
	
	return 1;
}

int lwm2_file_reader_def_sensor(sensor_def_t* sensor)
{
	char sensor_name[32];
	char split_char1[4];
	char split_char2[4];
	char end_char[4];
	
	if(feof(rdef_file_handle) == 0)
	{
		int tkns = fscanf(rdef_file_handle, "%[^:]%[:]%hu%[=]%[^\n]%[\n]", sensor_name, split_char1, &sensor->sensor_id, split_char2, sensor->sensor_name, end_char);
		
		if(tkns < 6)
		{
			return 0;
		}
		
		return 1;
	}
	
	return 0;
}

int lwm2_file_reader_def_process_mapping(process_map_t* process_mapping)
{
	char process_name[32];
	char split_char1[4];
	char split_char2[4];
	char end_char[4];
	
	if(feof(rdef_file_handle) == 0)
	{
		int tkns = fscanf(rdef_file_handle, "%[^:]%[:]%u%[=]%[^\n]%[\n]", process_name, split_char1, &process_mapping->proc_id, split_char2, process_mapping->node_name, end_char);
		
		if(tkns < 6)
		{
			return 0;
		}
		
		return 1;
	}
	
	return 0;
}

int lwm2_file_reader_def_finish()
{
	fclose(rdef_file_handle);
	return 1;
}


