/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "../include/lwm2-file-writer-def.h"

#include <stdio.h>

#define CHECK_HANDLE(X) if((X) == NULL) { return; }

FILE* def_file_handle = NULL;

void lwm2_file_write_def_file_def(char* file_name, file_def_t file_definition)
{
	def_file_handle = fopen(file_name, "w");
	CHECK_HANDLE(def_file_handle);
	
	fprintf(def_file_handle, "version=%d\n", file_definition.version);
	
	fprintf(def_file_handle, "time_slice_length=%d\n", file_definition.time_slice_length);
	fprintf(def_file_handle, "time_slice_count=%lu\n", file_definition.time_slice_count);
	fprintf(def_file_handle, "time_slice_start_time=%lu\n", file_definition.time_slice_start_time);
	fprintf(def_file_handle, "summary_sensor_count=%hd\n", file_definition.summary_metric_count);
	fprintf(def_file_handle, "time_slice_sensor_count=%hd\n", file_definition.time_slice_metric_count);
	fprintf(def_file_handle, "job_id=%u\n", file_definition.job_id);
	fprintf(def_file_handle, "process_count=%u\n", file_definition.process_count);
}

void lwm2_file_write_def_sensor(sensor_def_t sensor)
{
	CHECK_HANDLE(def_file_handle);
	fprintf(def_file_handle, "sensor:%hd=%s\n", sensor.sensor_id, sensor.sensor_name);
}

void lwm2_file_write_def_process_mapping(process_map_t proc_mapping)
{
	CHECK_HANDLE(def_file_handle);
	fprintf(def_file_handle, "process:%u=%s\n", proc_mapping.proc_id, proc_mapping.node_name);
}

void lwm2_file_write_def_finish()
{
	CHECK_HANDLE(def_file_handle);
	fclose(def_file_handle);
}
