/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <signal.h>
#include <stdlib.h>
#include <stdio.h>

#include "lwm2-signal.h"
#include "util/lwm2-log.h"

#include "lwm2-error-handling.h"

static void lwm2_error_sigsegv_handler(int sig_nr, siginfo_t* info, void *context)
{
	/* Prevent other signal handler from running */
	volatile sig_atomic_t lwm2_error_original_skip_signal = lwm2_skip_signal;
	lwm2_skip_signal = 1;

	/* Check to see if signal was caused by us */

		/* Do something */
		printf("Warning: A segmentation fault occured inside lwm2, the module will now shutdown. \n");

		/* Deactivate module completely */

		/* TODO: maybe only deactivate measurement system? */


	/* Restore original state */
	lwm2_skip_signal = lwm2_error_original_skip_signal;
	
	exit(-1);
}

int lwm2_error_init(void)
{
	struct sigaction sa;

	/* Install sigsegv handler */
	sa.sa_sigaction = lwm2_error_sigsegv_handler;
	sa.sa_flags = SA_SIGINFO;

	return LWM2_SUCCESS;
}

/* For testing purposes */
int lwm2_error_cause_error(void)
{
	int* t = NULL;
	t[1] =32;

	return LWM2_ERROR;
}
