/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef H_LWM2_SIGNAL
#define H_LWM2_SIGNAL

#include <signal.h>
#include <time.h>

#include "lwm2-config.h"

#include "util/util_time_measurement.h"

extern int lwm2_sys_service_active;

void lwm2_init(void);


void lwm2_end(void);

void read_thread_hwc(int sig_nr, siginfo_t* info, void *context);

long lwm2_signal_get_signals_till_time_slice();

void lwm2_signal_update_time_slice();

void lwm2_signal_switch_thread_buffers();

void lwm2_timer_disable();

int get_omp_thread_id();

void lwm2_get_job_id_juropa();

void lwm2_get_job_id();

long lwm2_get_sampling_rate();

int lwm2_get_time_slice_length();

void timer_enable(void);

/* Global flags */
extern unsigned int lwm2_initialized;

/**
 * Instruct signal handler to skip signals
 */
extern volatile sig_atomic_t lwm2_skip_signal;


extern long lwm2_sampling_rate;

extern long lwm2_timer_interval;

extern int lwm2_sys_service_active;
extern int lwm2_app_ended;
extern int lwm2_job_id;

extern timestamp_t lwm2_first_time_slice;
extern timestamp_t lwm2_start_time;
extern timestamp_t lwm2_end_time;
extern time_t lwm2_long_start_time;

extern int lwm2_time_slice_duration;


#endif
