/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdlib.h>
#include <stdio.h>

#include "lwm2-system.h"

/*
 * Get the name of the binary file
 */
void lwm2_system_binary_name(char* name)
{
#ifdef LWM2_SYSTEM_LINUX
	name[0] = '\0';

	/*  */
	FILE* name_file = fopen("/proc/self/cmdline", "r");
	if (NULL != name_file)
	{
		name = fgets(name, 1024, name_file);
	}
	fclose(name_file);
#else
	/* Default, it not specified */
#endif
}

/*
 * Get name through the PID of the application
 */
void lwm2_system_get_name(int prog_pid, char* name)
{
	name[0] = 0;

	char file_name[256];
	sprintf(file_name, "/proc/%d/cmdline", prog_pid);
	FILE *name_file = fopen(file_name, "r");
	if(name_file != NULL)
	{
		name = fgets(name, 1024, name_file);
	}
	fclose(name_file);
}

