/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef LWM2_MEASUREMENT_CUDA_H_
#define LWM2_MEASUREMENT_CUDA_H_

#include "../../adapter/lwm2-cuda-adapter.h"

void lwm2_measurement_setup_cuda();

void lwm2_measurement_teardown_cuda();

void lwm2_measurement_handle_signal_cuda();

void lwm2_measurement_read_cuda_counters();

#ifdef LWM2_MEASUREMENT_CUDA

void CUPTIAPI lwm2_cuda_handle_context(void *userdata, CUpti_CallbackDomain domain,
                      CUpti_CallbackId cbid, const CUpti_CallbackData *cbInfo);

void read_events_values(context_event_t* ctx, unsigned char device);

void only_read_context_events_for_current();

context_event_t* get_sub_context(CUcontext ctx, CUdevice device);

typedef struct dev_data {
	CUpti_EventGroup event_group;
	uint64_t values[LWM2_CUDA_EVENT_COUNT];
 } dev_data_t;


#endif

 
#endif
