/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdio.h>

#include "../../util/util_time_measurement.h"


#include "lwm2-measurement-mpi.h"

#include "../../adapter/lwm2-mpi-adapter.h"

#include "../../lwm2-signal.h"

// MPI header
#include <mpi.h>

/**
 * Module setup
 */
void lwm2_measurement_setup_mpi()
{

}

/**
 * Module teardown
 */
void lwm2_measurement_teardown_mpi()
{

}

/**
 * Handles one individual signal
 */
void lwm2_measurement_handle_signal_mpi()
{
#ifndef LWM2_MPI_REGULAR
	if(lwm2_storage_get_flag_mpi())
	{
		lwm2_storage_increment_signal_mpi();
	}
	
	if(lwm2_storage_get_flag_mpi_p2p())
	{
		lwm2_storage_increment_signal_mpi_p2p();
	}
	
	if(lwm2_storage_get_flag_mpi_coll())
	{
		lwm2_storage_increment_signal_mpi_coll();
	}
#endif
}
