/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/* Standard header */

#include "../../lwm2-config.h"

#define _GNU_SOURCE
#ifndef LWM2_NO_DLSYM
#include <dlfcn.h>
#endif
#include <stdio.h>
#include <signal.h>

/* lwm2 */
#include "../../lwm2-signal.h"
#include "../../util/lwm2-log.h"
#include "../../adapter/lwm2-pthread-adapter.h"

/* Specific header */
#include "lwm2-measurement-omp.h"

/* OpenMP header */
#include <omp.h>

#include "../../adapter/lwm2-omp-adapter.h"

/* Flag if omp library can be found (and ergo OpenMP is active) */

#ifndef LWM2_NO_DLSYM
typedef int (*func_t)();
func_t handle_omp_in_parallel = NULL;
#endif

/**
 * Module setup
 */
void lwm2_measurement_setup_omp(void)
{
	lwm2_wrapper_omp_init();
}

/**
 * Module teardown
 */
void lwm2_measurement_teardown_omp(void)
{

}

/**
 * Handles one individual signal
 */
void lwm2_measurement_handle_signal_omp()
{
	
}
