/****************************************************************************
**  Copyright (c) 2011-2012                                                **
**  German Research School for Simulation Sciences GmbH					   **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "lwm2_ignore_reader.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

char lwm2_ignore_names[MAX_IGNORE][IGNORE_NAME_LEN];
int lwm2_ignore_count = 0;

void lwm2_read_ignore_file()
{
	char* ignore_file_loc = getenv("LWM2_IGNORE_LIST");
	lwm2_ignore_count = 0;
	
	if(ignore_file_loc == NULL)
	{
		return;
	}
	
	FILE *fh = fopen(ignore_file_loc, "r");
	
	if(fh == NULL)
	{
		return;
	}
	
	while(feof(fh) == 0)
	{
		fscanf(fh, "%s", lwm2_ignore_names[lwm2_ignore_count++]);
	}
	lwm2_ignore_count--;
}

int lwm2_should_ignore(char* name)
{
	int i;
	
	if(name == NULL)
	{
		return 1;
	}
	
	
	for(i = 0; i < lwm2_ignore_count; i++)
	{
		if(strstr(name, lwm2_ignore_names[i]) != NULL)
		{
			return 1;
		}
	}
	return 0;
}
